local Tiers = {
				[4] = "T4 Shattrath (Magtheridon/Karazhan/Gruul)",							-- BC
				[5] = "T5 Shattrath (TK:Eye/Serpentshrine Cavern)",							-- BC
				[6] = "T6 Isle of Quel'Danas (Sunwell Plateau/Mount Hyjal/Black Temple)",	-- BC
				[7] = "T7 Dalaran (Naxxramas/Obsidian Sanctum)",							-- WOTLK
				[8] = "T8 Dalaran (Ulduar)",												-- WOTLK
				[9] = "T9 Crusaders' Coliseum (Trial of the Grand Crusader)",				-- WOTLK
				[10] = "T10 Inside ICC (Icecrown Citadel)",									-- WOTLK
				[11] = "T11 Capital City (Bastion of Twilight/Blackwing Descent)",			-- Cata
				[12] = "T12 Capital City (Firelands)",										-- Cata
				[13] = "T13 Capital City (Dragon Soul)",									-- Cata
				[14] = "T14 Townlong Steppes (Terrace of Endless Spring/Heart of Fear)",	-- MOP
				[15] = "T15 Townlong Steppes/Isle of Thunder (Throne of Thunder)",			-- MOP
				[16] = "T16 Shrine of 2 Moons/7 Stars (Siege of Orgrimmar)",				-- MOP
				[17] = "T17 Use Item (Highmaul/Blackrock Foundry)",							-- WOD
			  };

local ClassMap = {
					Vanquisher = {
									ROGUE = 4,
									MAGE = 4,
									DRUID = 4,
									DEATHKNIGHT = 7,
								 },
					Protector  = {
									WARRIOR = 4,
									HUNTER = 4,
									SHAMAN = 4,
									MONK = 14,
								 },
					Conqueror  = {
									PALADIN = 4,
									PRIEST = 4,
									WARLOCK = 4,
								 },
					Hero	   = {
									HUNTER = 4,
									MAGE = 4,
									WARLOCK = 4,
								 },
					Defender   = {
									WARRIOR = 4,
									PRIEST = 4,
									DRUID = 4,
								 },
					Champion   = {
									PALADIN = 4,
									ROGUE = 4,
									SHAMAN = 4,
								 },
				 };

local Tokens = {};
local Sets = {};

local NORMAL = 1;
local HEROIC = 2;
local RAID10 = 3;
local RAID25 = 4;
local HERO25 = 6;
local LFRAID = 7;
local FLEXXI = 13;
local MYTHIC = 16;

--Death Knight
local BLD = 250
local FRO = 251
local UNH = 252
--Druid
local BAL = 102
local FRL = 103
local GRD = 104
local RST = 105
--Hunter
local BST = 253
local MMS = 254
local SRV = 255
--Mage
local ARC = 62
local FIR = 63
local FST = 64
--Monk
local BRW = 268
local WND = 269
local MST = 270
--Paladin
local HOL = 65
local PRO = 66
local RET = 70
--Priest
local DSC = 256
local HLY = 257
local SHA = 258
--Rogue
local ASS = 259
local CMB = 260
local SUB = 261
--Shaman
local ELE = 262
local ENH = 263
local RTO = 264
--Warlock
local AFF = 265
local DEM = 266
local DES = 267
--Warrior
local ARM = 71
local FRY = 72
local PRT = 73

local function RegisterTokens(tier,diff,source,...) -- list of tokens
	local n = select("#",...)
	for i = 1,n do
		local v = select(i,...);
        if Tokens[v] then
            print("ERROR: duplicate itemid",v,tier,diff);
		else
			Tokens[v] = {};
			Tokens[v].tier = tier;
			Tokens[v].diff = diff;
			Tokens[v].source = source;
        end
	end
end

local function AddSet(tier,specmin,specmax,diff,...) -- list of items
	if (not Sets[tier]) then
		Sets[tier] = {};
	end
	if (not Sets[tier][diff]) then
		Sets[tier][diff] = {};
	end
	for s = specmin,specmax do
		Sets[tier][diff][s] = {...};
	end
end

-- item:id:0:0:0:0:0:0:0:level=100:0:diffid:count=1:bonus
local function T17(item,diffid,bonus)
	return "item:"..item..":0:0:0:0:0:0:0:100:0:"..diffid..":1:"..bonus;
end

-- "Fallen" tokens
-- Hero hunter,mage,warlock
-- Defender warrior,priest,druid
-- Champion paladin,rogue,shaman
RegisterTokens(4,NORMAL,"Magtheridon", 				29753,29754,29755); -- chestguard
RegisterTokens(4,NORMAL,"The Curator",				29756,29757,29758); -- gloves
RegisterTokens(4,NORMAL,"Prince Malchezaar", 		29759,29760,29761); -- helm
RegisterTokens(4,NORMAL,"High King Maulgar", 		29762,29763,29764); -- pauldrons
RegisterTokens(4,NORMAL,"Gruul the Dragonkiller", 	29765,29766,29767); -- leggings
-- Druid H,T,M,R
AddSet(4,RST,RST,NORMAL, 29086,29087,29088,29089,29090);
AddSet(4,FRL,GRD,NORMAL, 29096,29097,29098,29099,29100);
AddSet(4,BAL,BAL,NORMAL, 29091,29092,29093,29094,29095);
-- Hunter                                             
AddSet(4,BST,SRV,NORMAL, 29081,29082,29083,29084,29085);
-- Mage                                               
AddSet(4,ARC,FST,NORMAL, 29076,29077,29078,29079,29080);
-- Paladin H,T,M                                      
AddSet(4,HOL,HOL,NORMAL, 29061,29062,29063,29064,29065);
AddSet(4,PRO,PRO,NORMAL, 29066,29067,29068,29069,29070);
AddSet(4,RET,RET,NORMAL, 29071,29072,29073,29074,29075);
-- Priest H,R                                         
AddSet(4,DSC,HLY,NORMAL, 29049,29050,29053,29054,29055);
AddSet(4,SHA,SHA,NORMAL, 29056,29057,29058,29059,29060);
-- Rogue                                              
AddSet(4,ASS,SUB,NORMAL, 29044,29045,29046,29047,29048);
-- Shaman H,M,R                                       
AddSet(4,RTO,RTO,NORMAL, 29028,29029,29030,29031,29032);
AddSet(4,ENH,ENH,NORMAL, 29038,29039,29040,29042,29043);
AddSet(4,ELE,ELE,NORMAL, 29033,29034,29035,29036,29037);
-- Warlock                                            
AddSet(4,AFF,DES,NORMAL, 28963,28964,28966,28967,28968);
-- Warrior T,M                                        
AddSet(4,PRT,PRT,NORMAL, 29011,29012,29015,29016,29017);
AddSet(4,ARM,FRY,NORMAL, 29019,29020,29021,29022,29023);

-- "Vanquished" tokens
-- Hero hunter,mage,warlock
-- Defender warrior,priest,druid
-- Champion paladin,rogue,shaman
RegisterTokens(5,NORMAL,"Kael'thas Sunstrider", 	30236,30237,30238); -- chestguard
RegisterTokens(5,NORMAL,"Leotheras the Blind",		30239,30240,30241); -- gloves
RegisterTokens(5,NORMAL,"Lady Vashj",				30242,30243,30244); -- helm
RegisterTokens(5,NORMAL,"Fathom-Lord Karathress",	30245,30246,30247); -- leggings
RegisterTokens(5,NORMAL,"Void Reaver",				30248,30249,30250); -- pauldrons
-- Druid H,T,M,R
AddSet(5,RST,RST,NORMAL, 30216,30217,30219,30220,30221);
AddSet(5,FRL,GRD,NORMAL, 30222,30223,30228,30229,30230);
AddSet(5,BAL,BAL,NORMAL, 30231,30232,30233,30234,30235);
-- Hunter                                        
AddSet(5,BST,SRV,NORMAL, 30139,30140,30141,30142,30143);
-- Mage                                          
AddSet(5,ARC,FST,NORMAL, 30196,30205,30206,30207,30210);
-- Paladin H,T,M                                 
AddSet(5,HOL,HOL,NORMAL, 30134,30135,30136,30137,30138);
AddSet(5,PRO,PRO,NORMAL, 30123,30124,30125,30126,30127);
AddSet(5,RET,RET,NORMAL, 30129,30130,30131,30132,30133);
-- Priest H,R                                    
AddSet(5,DSC,HLY,NORMAL, 30150,30151,30152,30153,30154);
AddSet(5,SHA,SHA,NORMAL, 30159,30160,30161,30162,30163);
-- Rogue                                         
AddSet(5,ASS,SUB,NORMAL, 30144,30145,30146,30148,30149);
-- Shaman H,M,R                                  
AddSet(5,RTO,RTO,NORMAL, 30164,30165,30166,30167,30168);
AddSet(5,ENH,ENH,NORMAL, 30185,30189,30190,30192,30194);
AddSet(5,ELE,ELE,NORMAL, 30169,30170,30171,30172,30173);
-- Warlock                                       
AddSet(5,AFF,DES,NORMAL, 30214,30211,30212,30213,30215);
-- Warrior T,M                                   
AddSet(5,PRT,PRT,NORMAL, 30113,30114,30115,30116,30117);
AddSet(5,ARM,FRY,NORMAL, 30118,30119,30120,30121,30122);

-- "Forgotten" tokens
-- Vanquisher rogue,mage,druid
-- Protector warrior,hunter,shaman
-- Conqueror paladin,priest,warlock
RegisterTokens(6,NORMAL,"Illidan Stormrage", 									31089,31090,31091); -- chestguard
RegisterTokens(6,NORMAL,"Azgalor", 												31092,31093,31094); -- gloves
RegisterTokens(6,NORMAL,"Archimonde", 											31095,31096,31097); -- helm
RegisterTokens(6,NORMAL,"Gathios the Shatterer/Lady Maland/Veras Darkshadow", 	31098,31099,31100); -- leggings
RegisterTokens(6,NORMAL,"Mother Shahraz", 										31101,31102,31103); -- pauldrons
RegisterTokens(6,NORMAL,"Sathrovarr the Corruptor", 							34848,34851,34852); -- bracers
RegisterTokens(6,NORMAL,"Brutallus", 											34853,34854,34855); -- belt
RegisterTokens(6,NORMAL,"Felmyst",												34856,34857,34858); -- boots
-- Druid H,T,M,R
AddSet(6,RST,RST,NORMAL, 31032,31037,31041,31045,31047,34445,34554,34571);
AddSet(6,FRL,GRD,NORMAL, 31034,31039,31042,31044,31048,34444,34556,34573);
AddSet(6,BAL,BAL,NORMAL, 31035,31040,31043,31046,31049,34446,34555,34572);
-- Hunter                            
AddSet(6,BST,SRV,NORMAL, 31001,31003,31004,31005,31006,34443,34549,34570);
-- Mage                              
AddSet(6,ARC,FST,NORMAL, 31055,31056,31057,31058,31059,34447,34557,34574);
-- Paladin H,T,M                     
AddSet(6,HOL,HOL,NORMAL, 30983,30988,30992,30994,30996,34432,34487,34559);
AddSet(6,PRO,PRO,NORMAL, 30985,30987,30991,30995,30998,34433,34488,34560);
AddSet(6,RET,RET,NORMAL, 30982,30989,30990,30993,30997,34431,34485,34561);
-- Priest H,R                        
AddSet(6,DSC,HLY,NORMAL, 31060,31063,31066,31068,31069,34435,34527,34562);
AddSet(6,SHA,SHA,NORMAL, 31061,31064,31065,31067,31070,34434,34528,34563);
-- Rogue                             
AddSet(6,ASS,SUB,NORMAL, 31026,31027,31028,31029,31030,34448,34558,34575);
-- Shaman H,M,R                      
AddSet(6,RTO,RTO,NORMAL, 31007,31012,31016,31019,31022,34438,34543,34565);
AddSet(6,ENH,ENH,NORMAL, 31011,31015,31018,31021,31024,34439,34545,34567);
AddSet(6,ELE,ELE,NORMAL, 31008,31014,31017,31020,31023,34437,34542,34566);
-- Warlock                           
AddSet(6,AFF,DES,NORMAL, 31050,31051,31052,31053,31054,34436,34541,34564);
-- Warrior T,M                       
AddSet(6,PRT,PRT,NORMAL, 30970,30974,30976,30978,30980,34442,34547,34568);
AddSet(6,ARM,FRY,NORMAL, 30969,30972,30975,30977,30979,34441,34546,34569);

-- "Lost" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman
-- Conqueror paladin,priest,warlock
RegisterTokens(7,RAID10,"Gluth/4 Horsemen",	40610,40611,40612); -- chestguard
RegisterTokens(7,RAID10,"Sartharion", 		40613,40614,40615); -- gloves
RegisterTokens(7,RAID10,"Kel'Thuzad", 		40616,40617,40618); -- helm
RegisterTokens(7,RAID10,"Thaddius", 		40619,40620,40621); -- leggings
RegisterTokens(7,RAID10,"Loatheb", 			40622,40623,40624); -- spaulders
RegisterTokens(7,RAID25,"Gluth/4 Horsemen", 40625,40626,40627); -- breastplate
RegisterTokens(7,RAID25,"Sartharion", 		40628,40629,40630); -- gauntlets
RegisterTokens(7,RAID25,"Kel'Thuzad", 		40631,40632,40633); -- crown
RegisterTokens(7,RAID25,"Thaddius", 		40634,40635,40636); -- legplates
RegisterTokens(7,RAID25,"Loatheb", 			40637,40638,40639); -- mantle
-- Druid H,T,M,R
AddSet(7,RST,RST,RAID10, 39531,39538,39539,39542,39543);
AddSet(7,RST,RST,RAID25, 40461,40462,40463,40465,40460);
AddSet(7,FRL,GRD,RAID10, 39553,39554,39555,39556,39557);
AddSet(7,FRL,GRD,RAID25, 40471,40472,40473,40493,40494);
AddSet(7,BAL,BAL,RAID10, 39544,39545,39546,39547,39548);
AddSet(7,BAL,BAL,RAID25, 40466,40467,40468,40469,40470);
-- Hunter                                 
AddSet(7,BST,SRV,RAID10, 39578,39579,39580,39581,39582);
AddSet(7,BST,SRV,RAID25, 40503,40504,40505,40506,40507);
-- Mage                                   
AddSet(7,ARC,FST,RAID10, 39491,39492,39493,39494,39495);
AddSet(7,ARC,FST,RAID25, 40415,40416,40417,40418,40419);
-- Paladin H,T,M                          
AddSet(7,HOL,HOL,RAID10, 39628,39629,39630,39631,39632);
AddSet(7,HOL,HOL,RAID25, 40569,40570,40571,40572,40573);
AddSet(7,PRO,PRO,RAID10, 39638,39639,39640,39641,39642);
AddSet(7,PRO,PRO,RAID25, 40579,40580,40581,40583,40584);
AddSet(7,RET,RET,RAID10, 39633,39634,39635,39636,39637);
AddSet(7,RET,RET,RAID25, 40574,40575,40576,40577,40578);
-- Priest H,R                             
AddSet(7,DSC,HLY,RAID10, 39514,39515,39517,39518,39519);
AddSet(7,DSC,HLY,RAID25, 40445,40447,40448,40449,40450);
AddSet(7,SHA,SHA,RAID10, 39521,39523,39528,39529,39530);
AddSet(7,SHA,SHA,RAID25, 40454,40456,40457,40458,40459);
-- Rogue                                  
AddSet(7,ASS,SUB,RAID10, 39558,39560,39561,39564,39565);
AddSet(7,ASS,SUB,RAID25, 40495,40496,40499,40500,40502);
-- Shaman H,M,R                           
AddSet(7,RTO,RTO,RAID10, 39583,39588,39589,39590,39591);
AddSet(7,RTO,RTO,RAID25, 40508,40509,40510,40512,40513);
AddSet(7,ENH,ENH,RAID10, 39597,39601,39602,39603,39604);
AddSet(7,ENH,ENH,RAID25, 40520,40521,40522,40523,40524);
AddSet(7,ELE,ELE,RAID10, 39592,39593,39594,39595,39596);
AddSet(7,ELE,ELE,RAID25, 40514,40515,40516,40517,40518);
-- Warlock                                
AddSet(7,AFF,DES,RAID10, 39496,39497,39498,39499,39500);
AddSet(7,AFF,DES,RAID25, 40420,40421,40422,40423,40424);
-- Warrior T,M                            
AddSet(7,PRT,PRT,RAID10, 39610,39611,39612,39613,39622);
AddSet(7,PRT,PRT,RAID25, 40544,40545,40546,40547,40548);
AddSet(7,ARM,FRY,RAID10, 39605,39606,39607,39608,39609);
AddSet(7,ARM,FRY,RAID25, 40525,40527,40528,40529,40530);
-- Death Knight T,M                       
AddSet(7,BLD,BLD,RAID10, 39623,39624,39625,39626,39627);
AddSet(7,BLD,BLD,RAID25, 40559,40563,40565,40567,40568);
AddSet(7,FRO,UNH,RAID10, 39617,39618,39619,39620,39621);
AddSet(7,FRO,UNH,RAID25, 40550,40552,40554,40556,40557);

-- "Wayward" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman
-- Conqueror paladin,priest,warlock
RegisterTokens(8,RAID10,"Yogg-Saron", 	45635,45636,45637); -- chestguard
RegisterTokens(8,RAID10,"Freya", 		45644,45645,45646); -- gloves
RegisterTokens(8,RAID10,"Mimiron", 		45647,45648,45649); -- helm
RegisterTokens(8,RAID10,"Hodir", 		45650,45651,45652); -- leggings
RegisterTokens(8,RAID10,"Thorim", 		45659,45660,45661); -- spaulders
RegisterTokens(8,RAID25,"Hodir",		45632,45633,45634); -- breastplate
RegisterTokens(8,RAID25,"Thorim", 		45638,45639,45640); -- crown
RegisterTokens(8,RAID25,"Mimiron", 		45641,45642,45643); -- gauntlets
RegisterTokens(8,RAID25,"Freya", 		45653,45654,45655); -- legplates
RegisterTokens(8,RAID25,"Yogg-Saron", 	45656,45657,45658); -- mantle
-- Druid H,T,M,R
AddSet(8,RST,RST,RAID10, 45345,45346,45347,45348,45349);
AddSet(8,RST,RST,RAID25, 46183,46184,46185,46186,46187);
AddSet(8,FRL,GRD,RAID10, 45355,45356,45357,45358,45359);
AddSet(8,FRL,GRD,RAID25, 46157,46158,46159,46160,46161);
AddSet(8,BAL,BAL,RAID10, 45351,45352,45353,45354,46313);
AddSet(8,BAL,BAL,RAID25, 46189,46191,46192,46194,46196);
-- Hunter
AddSet(8,BST,SRV,RAID10, 45360,45361,45362,45363,45364);
AddSet(8,BST,SRV,RAID25, 46141,46142,46143,46144,46145);
-- Mage
AddSet(8,ARC,FST,RAID10, 45365,45367,45368,45369,46131);
AddSet(8,ARC,FST,RAID25, 46129,46130,46132,46133,46134);
-- Paladin H,T,M
AddSet(8,HOL,HOL,RAID10, 45370,45371,45372,45373,45374);
AddSet(8,HOL,HOL,RAID25, 46178,46179,46180,46181,46182);
AddSet(8,PRO,PRO,RAID10, 45381,45382,45383,45384,45385);
AddSet(8,PRO,PRO,RAID25, 46173,46174,46175,46176,46177);
AddSet(8,RET,RET,RAID10, 45375,45376,45377,45379,45380);
AddSet(8,RET,RET,RAID25, 46152,46153,46154,46155,46156);
-- Priest H,R
AddSet(8,DSC,HLY,RAID10, 45386,45387,45388,45389,45390);
AddSet(8,DSC,HLY,RAID25, 46188,46197,46195,46193,46190);
AddSet(8,SHA,SHA,RAID10, 45392,45391,45394,45395,45393);
AddSet(8,SHA,SHA,RAID25, 46163,46172,46170,46168,46165);
-- Rogue
AddSet(8,ASS,SUB,RAID10, 45396,45397,45398,45399,45400);
AddSet(8,ASS,SUB,RAID25, 46123,46124,46125,46126,46127);
-- Shaman H,M,R
AddSet(8,RTO,RTO,RAID10, 45401,45402,45403,45404,45405);
AddSet(8,RTO,RTO,RAID25, 46198,46199,46201,46202,46204);
AddSet(8,ENH,ENH,RAID10, 45412,45413,45414,45415,45416);
AddSet(8,ENH,ENH,RAID25, 46200,46203,46205,46208,46212);
AddSet(8,ELE,ELE,RAID10, 45406,45408,45409,45410,45411);
AddSet(8,ELE,ELE,RAID25, 46206,46207,46209,46210,46211);
-- Warlock
AddSet(8,AFF,DES,RAID10, 45417,45419,45420,45421,45422);
AddSet(8,AFF,DES,RAID25, 46135,46136,46137,46139,46140);
-- Warrior T,M
AddSet(8,PRT,PRT,RAID10, 45424,45425,45426,45427,45428);
AddSet(8,PRT,PRT,RAID25, 46162,46164,46166,46167,46169);
AddSet(8,ARM,FRY,RAID10, 45429,45430,45431,45432,45433);
AddSet(8,ARM,FRY,RAID25, 46146,46148,46149,46150,46151);
-- Death Knight T,M
AddSet(8,BLD,BLD,RAID10, 45335,45336,45337,45338,45339);
AddSet(8,BLD,BLD,RAID25, 46118,46119,46120,46121,46122);
AddSet(8,FRO,UNH,RAID10, 45340,45341,45342,45343,45344);
AddSet(8,FRO,UNH,RAID25, 46111,46113,46115,46116,46117);

-- "Grand" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman
-- Conqueror paladin,priest,warlock
RegisterTokens(9,RAID25,"Any Boss", 	47242); -- Trophy of the Crusade (inv misc)
RegisterTokens(9,HERO25,"unavailable", 	47557,47558,47559); -- no longer available to loot
if (UnitFactionGroup("player") == "Alliance") then
-- Druid H,T,M,R
AddSet(9,RST,RST,RAID25, 48133,48134,48135,48136,48137);
AddSet(9,RST,RST,HERO25, 48138,48139,48140,48141,48142);
AddSet(9,FRL,GRD,RAID25, 48208,48209,48210,48211,48212);
AddSet(9,FRL,GRD,HERO25, 48203,48204,48205,48206,48207);
AddSet(9,BAL,BAL,RAID25, 48163,48164,48165,48166,48167);
AddSet(9,BAL,BAL,HERO25, 48168,48169,48170,48171,48172);
-- Hunter
AddSet(9,BST,SRV,RAID25, 48255,48256,48257,48258,48259);
AddSet(9,BST,SRV,HERO25, 48260,48264,48261,48262,48263);
-- Mage
AddSet(9,ARC,FST,RAID25, 47753,47754,47755,47756,47757);
AddSet(9,ARC,FST,HERO25, 47758,47759,47760,47761,47762);
-- Paladin H,T,M
AddSet(9,HOL,HOL,RAID25, 48576,48577,48578,48575,48579);
AddSet(9,HOL,HOL,HERO25, 48580,48581,48582,48583,48584);
AddSet(9,PRO,PRO,RAID25, 48637,48638,48639,48640,48641);
AddSet(9,PRO,PRO,HERO25, 48642,48643,48644,48645,48646);
AddSet(9,RET,RET,RAID25, 48607,48608,48609,48610,48611);
AddSet(9,RET,RET,HERO25, 48612,48613,48614,48615,48616);
-- Priest H,R
AddSet(9,DSC,HLY,RAID25, 47983,47984,47985,47986,47987);
AddSet(9,DSC,HLY,HERO25, 48029,48031,48033,48035,48037);
AddSet(9,SHA,SHA,RAID25, 48077,48078,48079,48080,48081);
AddSet(9,SHA,SHA,HERO25, 48082,48083,48084,48085,48086);
-- Rogue
AddSet(9,ASS,SUB,RAID25, 48223,48224,48225,48226,48227);
AddSet(9,ASS,SUB,HERO25, 48228,48229,48230,48231,48232);
-- Shaman H,M,R
AddSet(9,RTO,RTO,RAID25, 48285,48286,48287,48288,48289);
AddSet(9,RTO,RTO,HERO25, 48290,48291,48292,48293,48294);
AddSet(9,ENH,ENH,RAID25, 48346,48347,48348,48349,48350);
AddSet(9,ENH,ENH,HERO25, 48351,48352,48353,48354,48355);
AddSet(9,ELE,ELE,RAID25, 48316,48317,48318,48319,48320);
AddSet(9,ELE,ELE,HERO25, 48321,48322,48323,48324,48325);
-- Warlock
AddSet(9,AFF,DES,RAID25, 47778,47779,47780,47781,47782);
AddSet(9,AFF,DES,HERO25, 47788,47789,47790,47791,47792);
-- Warrior T,M
AddSet(9,PRT,PRT,RAID25, 48430,48446,48450,48452,48454);
AddSet(9,PRT,PRT,HERO25, 48433,48447,48451,48453,48455);
AddSet(9,ARM,FRY,RAID25, 48376,48377,48378,48379,48380);
AddSet(9,ARM,FRY,HERO25, 48381,48382,48383,48384,48385);
-- Death Knight T,M
AddSet(9,BLD,BLD,RAID25, 48538,48539,48540,48541,48542);
AddSet(9,BLD,BLD,HERO25, 48543,48544,48545,48546,48547);
AddSet(9,FRO,UNH,RAID25, 48481,48482,48483,48484,48485);
AddSet(9,FRO,UNH,HERO25, 48486,48487,48488,48489,48490);
else
-- Druid H,T,M,R
AddSet(9,RST,RST,RAID25, 48148,48149,48150,48151,48152);
AddSet(9,RST,RST,HERO25, 48143,48144,48145,48146,48147);
AddSet(9,FRL,GRD,RAID25, 48193,48194,48195,48196,48197);
AddSet(9,FRL,GRD,HERO25, 48198,48199,48200,48201,48202);
AddSet(9,BAL,BAL,RAID25, 48178,48179,48180,48181,48182);
AddSet(9,BAL,BAL,HERO25, 48173,48174,48175,48176,48177);
-- Hunter
AddSet(9,BST,SRV,RAID25, 48270,48271,48272,48273,48274);
AddSet(9,BST,SRV,HERO25, 48265,48266,48267,48268,48269);
-- Mage
AddSet(9,ARC,FST,RAID25, 47768,47769,47770,47771,47772);
AddSet(9,ARC,FST,HERO25, 47763,47764,47765,47766,47767);
-- Paladin H,T,M
AddSet(9,HOL,HOL,RAID25, 48590,48591,48592,48593,48594);
AddSet(9,HOL,HOL,HERO25, 48585,48586,48587,48588,48589);
AddSet(9,PRO,PRO,RAID25, 48657,48658,48659,48660,48661);
AddSet(9,PRO,PRO,HERO25, 48647,48648,48649,48650,48651);
AddSet(9,RET,RET,RAID25, 48622,48623,48624,48625,48626);
AddSet(9,RET,RET,HERO25, 48617,48618,48619,48620,48621);
-- Priest H,R
AddSet(9,DSC,HLY,RAID25, 48062,48063,48064,48065,48066);
AddSet(9,DSC,HLY,HERO25, 48057,48058,48059,48060,48061);
AddSet(9,SHA,SHA,RAID25, 48092,48093,48094,48095,48096);
AddSet(9,SHA,SHA,HERO25, 48087,48088,48089,48090,48091);
-- Rogue
AddSet(9,ASS,SUB,RAID25, 48238,48239,48240,48241,48242);
AddSet(9,ASS,SUB,HERO25, 48233,48234,48235,48236,48237);
-- Shaman H,M,R
AddSet(9,RTO,RTO,RAID25, 48300,48301,48302,48303,48304);
AddSet(9,RTO,RTO,HERO25, 48305,48306,48307,48308,48309);
AddSet(9,ENH,ENH,RAID25, 48361,48362,48363,48364,48365);
AddSet(9,ENH,ENH,HERO25, 48356,48357,48358,48359,48360);
AddSet(9,ELE,ELE,RAID25, 48331,48332,48333,48334,48335);
AddSet(9,ELE,ELE,HERO25, 48326,48327,48328,48329,48330);
-- Warlock
AddSet(9,AFF,DES,RAID25, 47803,47804,47805,47806,47807);
AddSet(9,AFF,DES,HERO25, 47793,47794,47795,47796,47797);
-- Warrior T,M
AddSet(9,PRT,PRT,RAID25, 48461,48462,48463,48464,48465);
AddSet(9,PRT,PRT,HERO25, 48466,48467,48468,48469,48470);
AddSet(9,ARM,FRY,RAID25, 48391,48392,48393,48394,48395);
AddSet(9,ARM,FRY,HERO25, 48396,48397,48398,48399,48400);
-- Death Knight T,M
AddSet(9,BLD,BLD,RAID25, 48553,48554,48555,48556,48557);
AddSet(9,BLD,BLD,HERO25, 48548,48549,48550,48551,48552);
AddSet(9,FRO,UNH,RAID25, 48496,48497,48498,48499,48500);
AddSet(9,FRO,UNH,HERO25, 48491,48492,48493,48494,48495);
end

-- "Sanctification" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman
-- Conqueror paladin,priest,warlock
RegisterTokens(10,RAID25,"Any Boss", 52025,52026,52027);
RegisterTokens(10,HERO25,"Any Boss", 52028,52029,52030);
-- Druid H,T,M,R
AddSet(10,RST,RST,RAID25, 51135,51136,51137,51138,51139);
AddSet(10,RST,RST,HERO25, 51300,51301,51302,51303,51304);
AddSet(10,FRL,GRD,RAID25, 51140,51141,51142,51143,51144);
AddSet(10,FRL,GRD,HERO25, 51295,51296,51297,51298,51299);
AddSet(10,BAL,BAL,RAID25, 51145,51146,51147,51148,51149);
AddSet(10,BAL,BAL,HERO25, 51290,51291,51292,51293,51294);
-- Hunter
AddSet(10,BST,SRV,RAID25, 51150,51151,51152,51153,51154);
AddSet(10,BST,SRV,HERO25, 51285,51286,51287,51288,51289);
-- Mage
AddSet(10,ARC,FST,RAID25, 51155,51156,51157,51158,51159);
AddSet(10,ARC,FST,HERO25, 51280,51281,51282,51283,51284);
-- Paladin H,T,M
AddSet(10,HOL,HOL,RAID25, 51165,51166,51167,51168,51169);
AddSet(10,HOL,HOL,HERO25, 51270,51271,51272,51273,51274);
AddSet(10,PRO,PRO,RAID25, 51170,51171,51172,51173,51174);
AddSet(10,PRO,PRO,HERO25, 51265,51266,51267,51268,51269);
AddSet(10,RET,RET,RAID25, 51160,51161,51162,51163,51164);
AddSet(10,RET,RET,HERO25, 51275,51276,51277,51278,51279);
-- Priest H,R
AddSet(10,DSC,HLY,RAID25, 51175,51176,51177,51178,51179);
AddSet(10,DSC,HLY,HERO25, 51260,51261,51262,51263,51264);
AddSet(10,SHA,SHA,RAID25, 51180,51181,51182,51183,51184);
AddSet(10,SHA,SHA,HERO25, 51255,51256,51257,51258,51259);
-- Rogue
AddSet(10,ASS,SUB,RAID25, 51185,51186,51187,51188,51189);
AddSet(10,ASS,SUB,HERO25, 51251,51252,51253,51250,51254);
-- Shaman H,M,R
AddSet(10,RTO,RTO,RAID25, 51190,51191,51192,51193,51194);
AddSet(10,RTO,RTO,HERO25, 51245,51246,51247,51248,51249);
AddSet(10,ENH,ENH,RAID25, 51196,51197,51198,51195,51199);
AddSet(10,ENH,ENH,HERO25, 51240,51244,51241,51242,51243);
AddSet(10,ELE,ELE,RAID25, 51200,51201,51202,51203,51204);
AddSet(10,ELE,ELE,HERO25, 51235,51236,51237,51238,51239);
-- Warlock
AddSet(10,AFF,DES,RAID25, 51205,51206,51207,51208,51209);
AddSet(10,AFF,DES,HERO25, 51230,51231,51232,51233,51234);
-- Warrior T,M
AddSet(10,PRT,PRT,RAID25, 51215,51216,51217,51218,51219);
AddSet(10,PRT,PRT,HERO25, 51220,51221,51222,51223,51224);
AddSet(10,ARM,FRY,RAID25, 51210,51211,51213,51212,51214);
AddSet(10,ARM,FRY,HERO25, 51225,51226,51227,51228,51229);
-- Death Knight T,M
AddSet(10,BLD,BLD,RAID25, 51130,51131,51132,51133,51134);
AddSet(10,BLD,BLD,HERO25, 51305,51306,51307,51308,51309);
AddSet(10,FRO,UNH,RAID25, 51125,51126,51128,51127,51129);
AddSet(10,FRO,UNH,HERO25, 51310,51311,51312,51313,51314);

-- "Forlorn" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman
-- Conqueror paladin,priest,warlock
RegisterTokens(11,NORMAL,"Nefarian/4 Winds", 	63682,63683,63684); -- helm
RegisterTokens(11,NORMAL,"Cho'gall",		 	64314,64315,64316); -- mantle
RegisterTokens(11,HEROIC,"Nefarian/4 Winds", 	65000,65001,65002); -- crown
RegisterTokens(11,HEROIC,"Cho'gall", 		 	65087,65088,65089); -- shoulders
RegisterTokens(11,HEROIC,"4 Winds", 		 	66998); -- any
RegisterTokens(11,HEROIC,"Halfus Wyrmbreaker", 	67423,67424,67425); -- chest
RegisterTokens(11,HEROIC,"Maloriak", 			67426,67427,67428); -- leggings
RegisterTokens(11,HEROIC,"Magmaw", 				67429,67430,67431); -- gauntlets
-- Druid H,T,M,R
AddSet(11,RST,RST,NORMAL, 60276,60277,60278,60279,60280);
AddSet(11,RST,RST,HEROIC, 65194,65195,65196,65197,65198);
AddSet(11,FRL,GRD,NORMAL, 60286,60287,60288,60289,60290);
AddSet(11,FRL,GRD,HEROIC, 65189,65190,65191,65192,65193);
AddSet(11,BAL,BAL,NORMAL, 60281,60282,60283,60284,60285);
AddSet(11,BAL,BAL,HEROIC, 65199,65200,65201,65202,65203);
-- Hunter
AddSet(11,BST,SRV,NORMAL, 60303,60304,60305,60306,60307);
AddSet(11,BST,SRV,HEROIC, 65204,65205,65206,65207,65208);
-- Mage
AddSet(11,ARC,FST,NORMAL, 60243,60244,60245,60246,60247);
AddSet(11,ARC,FST,HEROIC, 65209,65210,65211,65212,65213);
-- Paladin H,T,M
AddSet(11,HOL,HOL,NORMAL, 60359,60360,60361,60362,60363);
AddSet(11,HOL,HOL,HEROIC, 65219,65220,65221,65222,65223);
AddSet(11,PRO,PRO,NORMAL, 60354,60355,60356,60357,60358);
AddSet(11,PRO,PRO,HEROIC, 65224,65225,65226,65227,65228);
AddSet(11,RET,RET,NORMAL, 60344,60345,60346,60347,60348);
AddSet(11,RET,RET,HEROIC, 65214,65215,65216,65217,65218);
-- Priest H,R
AddSet(11,DSC,HLY,NORMAL, 60258,60259,60261,60262,60275);
AddSet(11,DSC,HLY,HEROIC, 65229,65230,65231,65232,65233);
AddSet(11,SHA,SHA,NORMAL, 60253,60254,60255,60256,60257);
AddSet(11,SHA,SHA,HEROIC, 65234,65235,65236,65237,65238);
-- Rogue
AddSet(11,ASS,SUB,NORMAL, 60298,60299,60300,60301,60302);
AddSet(11,ASS,SUB,HEROIC, 65239,65240,65241,65242,65243);
-- Shaman H,M,R
AddSet(11,RTO,RTO,NORMAL, 60308,60309,60310,60311,60312);
AddSet(11,RTO,RTO,HEROIC, 65244,65245,65246,65247,65248);
AddSet(11,ENH,ENH,NORMAL, 60318,60319,60320,60321,60322);
AddSet(11,ENH,ENH,HEROIC, 65249,65250,65251,65252,65253);
AddSet(11,ELE,ELE,NORMAL, 60313,60314,60315,60316,60317);
AddSet(11,ELE,ELE,HEROIC, 65254,65255,65256,65257,65258);
-- Warlock
AddSet(11,AFF,DES,NORMAL, 60248,60249,60250,60251,60252);
AddSet(11,AFF,DES,HEROIC, 65259,65260,65261,65262,65263);
-- Warrior T,M
AddSet(11,PRT,PRT,NORMAL, 60328,60329,60330,60331,60332);
AddSet(11,PRT,PRT,HEROIC, 65269,65270,65271,65272,65273);
AddSet(11,ARM,FRY,NORMAL, 60323,60324,60325,60326,60327);
AddSet(11,ARM,FRY,HEROIC, 65264,65265,65266,65267,65268);
-- Death Knight T,M
AddSet(11,BLD,BLD,NORMAL, 60349,60350,60351,60352,60353);
AddSet(11,BLD,BLD,HEROIC, 65184,65185,65186,65187,65188);
AddSet(11,FRO,UNH,NORMAL, 60339,60340,60341,60342,60343);
AddSet(11,FRO,UNH,HEROIC, 65179,65180,65181,65182,65183);

-- "Fiery" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman
-- Conqueror paladin,priest,warlock
RegisterTokens(12,NORMAL,"Ragnaros", 			71668,71675,71682); -- helm
RegisterTokens(12,NORMAL,"Majordomo Staghelm",  71674,71681,71688); -- mantle
RegisterTokens(12,HEROIC,"Baleroc", 			71669,71676,71683); -- gauntlets
RegisterTokens(12,HEROIC,"Ragnaros", 			71670,71677,71684); -- crown
RegisterTokens(12,HEROIC,"Shannox", 			71671,71678,71685); -- leggings
RegisterTokens(12,HEROIC,"Alysrazor", 			71672,71679,71686); -- chest
RegisterTokens(12,HEROIC,"Majordomo Staghelm", 	71673,71680,71687); -- shoulders
-- Druid H,T,M,R
AddSet(12,RST,RST,NORMAL, 71102,71103,71104,71105,71106);
AddSet(12,RST,RST,HEROIC, 71491,71492,71493,71494,71495);
AddSet(12,FRL,GRD,NORMAL, 71097,71098,71099,71100,71101);
AddSet(12,FRL,GRD,HEROIC, 71487,71488,71489,71486,71490);
AddSet(12,BAL,BAL,NORMAL, 71107,71108,71109,71110,71111);
AddSet(12,BAL,BAL,HEROIC, 71496,71497,71498,71499,71500);
-- Hunter
AddSet(12,BST,SRV,NORMAL, 71050,71051,71052,71054,71053);
AddSet(12,BST,SRV,HEROIC, 71502,71503,71504,71501,71505);
-- Mage
AddSet(12,ARC,FST,NORMAL, 71286,71287,71288,71289,71290);
AddSet(12,ARC,FST,HEROIC, 71507,71508,71509,71510,71511);
-- Paladin H,T,M
AddSet(12,HOL,HOL,NORMAL, 71091,71092,71093,71094,71095);
AddSet(12,HOL,HOL,HEROIC, 71517,71518,71519,71520,71521);
AddSet(12,PRO,PRO,NORMAL, 70946,70947,70948,70949,70950);
AddSet(12,PRO,PRO,HEROIC, 71522,71523,71524,71525,71526);
AddSet(12,RET,RET,NORMAL, 71063,71064,71065,71066,71067);
AddSet(12,RET,RET,HEROIC, 71512,71513,71514,71515,71516);
-- Priest H,R
AddSet(12,DSC,HLY,NORMAL, 71271,71272,71273,71274,71275);
AddSet(12,DSC,HLY,HEROIC, 71527,71528,71529,71530,71531);
AddSet(12,SHA,SHA,NORMAL, 71276,71277,71278,71279,71280);
AddSet(12,SHA,SHA,HEROIC, 71532,71533,71534,71535,71536);
-- Rogue
AddSet(12,ASS,SUB,NORMAL, 71045,71046,71047,71048,71049);
AddSet(12,ASS,SUB,HEROIC, 71537,71538,71539,71540,71541);
-- Shaman H,M,R
AddSet(12,RTO,RTO,NORMAL, 71296,71297,71298,71299,71300);
AddSet(12,RTO,RTO,HEROIC, 71542,71543,71544,71545,71546);
AddSet(12,ENH,ENH,NORMAL, 71301,71302,71303,71304,71305);
AddSet(12,ENH,ENH,HEROIC, 71547,71548,71549,71550,71551);
AddSet(12,ELE,ELE,NORMAL, 71291,71292,71293,71294,71295);
AddSet(12,ELE,ELE,HEROIC, 71552,71553,71554,71555,71556);
-- Warlock
AddSet(12,AFF,DES,NORMAL, 71281,71282,71283,71284,71285);
AddSet(12,AFF,DES,HEROIC, 71594,71595,71596,71597,71598);
-- Warrior T,M
AddSet(12,PRT,PRT,NORMAL, 70941,70942,70943,70944,70945);
AddSet(12,PRT,PRT,HEROIC, 71604,71605,71606,71607,71608);
AddSet(12,ARM,FRY,NORMAL, 71068,71069,71070,71071,71072);
AddSet(12,ARM,FRY,HEROIC, 71599,71600,71601,71602,71603);
-- Death Knight T,M
AddSet(12,BLD,BLD,NORMAL, 70951,70952,70953,70954,70955);
AddSet(12,BLD,BLD,HEROIC, 71481,71482,71483,71484,71485);
AddSet(12,FRO,UNH,NORMAL, 71058,71059,71060,71061,71062);
AddSet(12,FRO,UNH,HEROIC, 71476,71477,71478,71479,71480);

-- "Corrupted" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman
-- Conqueror paladin,priest,warlock
RegisterTokens(13,LFRAID,"Ultraxion", 				78862,78863,78864); -- chest
RegisterTokens(13,LFRAID,"Warlord Zon'ozz", 		78865,78866,78867); -- gauntlets
RegisterTokens(13,LFRAID,"Warmaster Blackhorn", 	78868,78869,78870); -- crown
RegisterTokens(13,LFRAID,"Yor'sahj the Unsleeping", 78871,78872,78873); -- leggings
RegisterTokens(13,LFRAID,"Hagara the Stormbinder", 	78874,78875,78876); -- shoulders
RegisterTokens(13,NORMAL,"Hagara the Stormbinder", 	78170,78175,78180); -- shoulders
RegisterTokens(13,NORMAL,"Yor'sahj the Unsleeping", 78171,78176,78181); -- leggings
RegisterTokens(13,NORMAL,"Warmaster Blackhorn", 	78172,78177,78182); -- crown
RegisterTokens(13,NORMAL,"Warlord Zon'ozz", 		78173,78178,78183); -- gauntlets
RegisterTokens(13,NORMAL,"Ultraxion", 				78174,78179,78184); -- chest
RegisterTokens(13,HEROIC,"Ultraxion", 				78847,78848,78849); -- chest
RegisterTokens(13,HEROIC,"Warmaster Blackhorn", 	78850,78851,78852); -- crown
RegisterTokens(13,HEROIC,"Warlord Zon'ozz", 		78853,78854,78855); -- gauntlets
RegisterTokens(13,HEROIC,"Yor'sahj the Unsleeping", 78856,78857,78858); -- leggings
RegisterTokens(13,HEROIC,"Hagara the Stormbinder", 	78859,78860,78861); -- shoulders
-- Druid H,T,M,R
AddSet(13,RST,RST,LFRAID, 78755,78775,78785,78805,78835);
AddSet(13,RST,RST,NORMAL, 76749,76750,76751,76752,76753);
AddSet(13,RST,RST,HEROIC, 78660,78680,78690,78710,78740);
AddSet(13,FRL,GRD,LFRAID, 78779,78789,78808,78760,78838);
AddSet(13,FRL,GRD,NORMAL, 77013,77014,77015,77016,77017);
AddSet(13,FRL,GRD,HEROIC, 78665,78684,78694,78713,78743);
AddSet(13,BAL,BAL,LFRAID, 78757,78771,78791,78809,78839);
AddSet(13,BAL,BAL,NORMAL, 77018,77019,77020,77021,77022);
AddSet(13,BAL,BAL,HEROIC, 78662,78676,78696,78714,78744);
-- Hunter
AddSet(13,BST,SRV,LFRAID, 78756,78769,78793,78804,78832);
AddSet(13,BST,SRV,NORMAL, 77028,77029,77030,77031,77032);
AddSet(13,BST,SRV,HEROIC, 78661,78674,78698,78709,78737);
-- Mage
AddSet(13,ARC,FST,LFRAID, 78824,78766,78796,78815,78843);
AddSet(13,ARC,FST,NORMAL, 76212,76213,76214,76215,76216);
AddSet(13,ARC,FST,HEROIC, 78671,78701,78720,78729,78748);
-- Paladin H,T,M
AddSet(13,HOL,HOL,LFRAID, 78768,78787,78812,78821,78841);
AddSet(13,HOL,HOL,NORMAL, 76765,76766,76767,76768,76769);
AddSet(13,HOL,HOL,HEROIC, 78673,78692,78717,78726,78746);
AddSet(13,PRO,PRO,LFRAID, 78772,78790,78810,78827,78840);
AddSet(13,PRO,PRO,NORMAL, 77003,77004,77005,77006,77007);
AddSet(13,PRO,PRO,HEROIC, 78677,78695,78715,78732,78745);
AddSet(13,RET,RET,LFRAID, 78770,78788,78807,78822,78837);
AddSet(13,RET,RET,NORMAL, 76874,76875,76876,76877,76878);
AddSet(13,RET,RET,HEROIC, 78675,78693,78712,78727,78742);
-- Priest H,R
AddSet(13,DSC,HLY,LFRAID, 78778,78795,78814,78823,78842);
AddSet(13,DSC,HLY,NORMAL, 76357,76358,76359,76360,76361);
AddSet(13,DSC,HLY,HEROIC, 78683,78700,78719,78728,78747);
AddSet(13,SHA,SHA,LFRAID, 78777,78798,78817,78826,78845);
AddSet(13,SHA,SHA,NORMAL, 76348,76347,76346,76345,76344);
AddSet(13,SHA,SHA,HEROIC, 78682,78703,78722,78731,78750);
-- Rogue
AddSet(13,ASS,SUB,LFRAID, 78774,78794,78803,78759,78833);
AddSet(13,ASS,SUB,NORMAL, 77023,77024,77025,77026,77027);
AddSet(13,ASS,SUB,HEROIC, 78664,78679,78699,78708,78738);
-- Shaman H,M,R
AddSet(13,RTO,RTO,LFRAID, 78767,78786,78813,78820,78834);
AddSet(13,RTO,RTO,NORMAL, 76757,76758,76759,76756,76760);
AddSet(13,RTO,RTO,HEROIC, 78672,78691,78718,78725,78739);
AddSet(13,ENH,ENH,LFRAID, 78762,78781,78799,78819,78828);
AddSet(13,ENH,ENH,NORMAL, 77041,77042,77043,77040,77044);
AddSet(13,ENH,ENH,HEROIC, 78667,78686,78704,78724,78733);
AddSet(13,ELE,ELE,LFRAID, 78761,78780,78806,78818,78836);
AddSet(13,ELE,ELE,NORMAL, 77038,77037,77036,77039,77035);
AddSet(13,ELE,ELE,HEROIC, 78666,78685,78711,78723,78741);
-- Warlock
AddSet(13,AFF,DES,LFRAID, 78776,78797,78816,78825,78844);
AddSet(13,AFF,DES,NORMAL, 76343,76342,76341,76340,76339);
AddSet(13,AFF,DES,HEROIC, 78681,78702,78721,78730,78749);
-- Warrior T,M
AddSet(13,PRT,PRT,LFRAID, 78753,78764,78784,78800,78829);
AddSet(13,PRT,PRT,NORMAL, 76988,76989,76990,76991,76992);
AddSet(13,PRT,PRT,HEROIC, 78658,78669,78689,78705,78734);
AddSet(13,ARM,FRY,LFRAID, 78752,78763,78783,78801,78830);
AddSet(13,ARM,FRY,NORMAL, 76983,76984,76985,76986,76987);
AddSet(13,ARM,FRY,HEROIC, 78657,78668,78688,78706,78735);
-- Death Knight T,M
AddSet(13,BLD,BLD,LFRAID, 78758,78773,78792,78811,78846);
AddSet(13,BLD,BLD,NORMAL, 77008,77009,77010,77011,77012);
AddSet(13,BLD,BLD,HEROIC, 78663,78678,78697,78716,78751);
AddSet(13,FRO,UNH,LFRAID, 78754,78765,78782,78802,78831);
AddSet(13,FRO,UNH,NORMAL, 76974,76975,76976,76977,76978);
AddSet(13,FRO,UNH,HEROIC, 78659,78670,78687,78707,78736);

-- "Shadowy" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman,monk
-- Conqueror paladin,priest,warlock
RegisterTokens(14,LFRAID,"Grand Empress Shek'zeer", 89264,89265,89266); -- chest
RegisterTokens(14,LFRAID,"Amber-Shaper Un'sok", 	89267,89268,89269); -- leggings
RegisterTokens(14,LFRAID,"Wind Lord Mel'jarak", 	89270,89271,89272); -- gauntlets
RegisterTokens(14,LFRAID,"Sha of Fear", 			89273,89274,89275); -- helm
RegisterTokens(14,LFRAID,"Lei Shi", 				89276,89277,89278); -- shoulders
RegisterTokens(14,NORMAL,"Sha of Fear", 			89234,89235,89236); -- helm
RegisterTokens(14,NORMAL,"Grand Empress Shek'zeer", 89237,89238,89239); -- chest
RegisterTokens(14,NORMAL,"Wind Lord Mel'jarak", 	89240,89241,89242); -- gauntlets
RegisterTokens(14,NORMAL,"Amber-Shaper Un'sok", 	89243,89244,89245); -- leggings
RegisterTokens(14,NORMAL,"Lei Shi", 				89246,89247,89248); -- shoulders
RegisterTokens(14,HEROIC,"Grand Empress Shek'zeer", 89249,89250,89251); -- chest
RegisterTokens(14,HEROIC,"Amber-Shaper Un'sok", 	89252,89253,89254); -- leggings
RegisterTokens(14,HEROIC,"Wind Lord Mel'jarak", 	89255,89256,89257); -- gauntlets
RegisterTokens(14,HEROIC,"Sha of Fear", 			89258,89259,89260); -- helm
RegisterTokens(14,HEROIC,"Lei Shi", 				89261,89262,89263); -- shoulders
-- Druid H,T,M,R
AddSet(14,RST,RST,LFRAID, 86646,86694,86695,86697,86698);
AddSet(14,RST,RST,NORMAL, 85306,85354,85355,85357,85358);
AddSet(14,RST,RST,HEROIC, 86929,86928,86931,86932,86935);
AddSet(14,GRD,GRD,LFRAID, 86719,86720,86721,86722,86723);
AddSet(14,GRD,GRD,NORMAL, 85379,85380,85381,85382,85383);
AddSet(14,GRD,GRD,HEROIC, 86938,86939,86940,86941,86942);
AddSet(14,FRL,FRL,LFRAID, 86649,86650,86651,86652,86653);
AddSet(14,FRL,FRL,NORMAL, 85309,85310,85311,85312,85313);
AddSet(14,FRL,FRL,HEROIC, 86923,86924,86925,86926,86927);
AddSet(14,BAL,BAL,LFRAID, 86644,86645,86647,86648,86696);
AddSet(14,BAL,BAL,NORMAL, 85304,85305,85307,85308,85356);
AddSet(14,BAL,BAL,HEROIC, 86930,86933,86934,86936,86937);
-- Hunter
AddSet(14,BST,SRV,LFRAID, 86634,86635,86636,86637,86638);
AddSet(14,BST,SRV,NORMAL, 85294,85295,85296,85297,85298);
AddSet(14,BST,SRV,HEROIC, 87002,87003,87004,87005,87006);
-- Mage
AddSet(14,ARC,FST,LFRAID, 86714,86715,86716,86717,86718);
AddSet(14,ARC,FST,NORMAL, 85374,85375,85376,85377,85378);
AddSet(14,ARC,FST,HEROIC, 87007,87008,87009,87010,87011);
-- Monk H,T,M
AddSet(14,MST,MST,LFRAID, 86729,86730,86731,86732,86733);
AddSet(14,MST,MST,NORMAL, 85389,85390,85391,85392,85393);
AddSet(14,MST,MST,HEROIC, 87089,87090,87091,87092,87093);
AddSet(14,BRW,BRW,LFRAID, 86724,86725,86726,86727,86728);
AddSet(14,BRW,BRW,NORMAL, 85384,85385,85386,85387,85388);
AddSet(14,BRW,BRW,HEROIC, 87094,87095,87096,87097,87098);
AddSet(14,WND,WND,LFRAID, 86734,86735,86736,86737,86738);
AddSet(14,WND,WND,NORMAL, 85394,85395,85396,85397,85398);
AddSet(14,WND,WND,HEROIC, 87084,87085,87086,87087,87088);
-- Paladin H,T,M
AddSet(14,HOL,HOL,LFRAID, 86684,86685,86686,86687,86688);
AddSet(14,HOL,HOL,NORMAL, 85344,85345,85346,85347,85348);
AddSet(14,HOL,HOL,HEROIC, 87104,87105,87106,87107,87108);
AddSet(14,PRO,PRO,LFRAID, 86659,86660,86661,86662,86663);
AddSet(14,PRO,PRO,NORMAL, 85319,85320,85321,85322,85323);
AddSet(14,PRO,PRO,HEROIC, 87109,87110,87111,87112,87113);
AddSet(14,RET,RET,LFRAID, 86679,86680,86681,86682,86683);
AddSet(14,RET,RET,NORMAL, 85339,85340,85341,85342,85343);
AddSet(14,RET,RET,HEROIC, 87099,87100,87101,87102,87103);
-- Priest H,R
AddSet(14,DSC,HLY,LFRAID, 86699,86700,86701,86702,86703);
AddSet(14,DSC,HLY,NORMAL, 85359,85360,85361,85362,85363);
AddSet(14,DSC,HLY,HEROIC, 87114,87115,87116,87117,87118);
AddSet(14,SHA,SHA,LFRAID, 86704,86705,86706,86707,86708);
AddSet(14,SHA,SHA,NORMAL, 85364,85365,85366,85367,85368);
AddSet(14,SHA,SHA,HEROIC, 87119,87120,87121,87122,87123);
-- Rogue
AddSet(14,ASS,SUB,LFRAID, 86639,86640,86641,86642,86643);
AddSet(14,ASS,SUB,NORMAL, 85299,85300,85301,85302,85303);
AddSet(14,ASS,SUB,HEROIC, 87124,87125,87126,87127,87128);
-- Shaman H,M,R
AddSet(14,RTO,RTO,LFRAID, 86689,86690,86691,86692,86693);
AddSet(14,RTO,RTO,NORMAL, 85349,85350,85351,85352,85353);
AddSet(14,RTO,RTO,HEROIC, 87129,87130,87131,87132,87133);
AddSet(14,ENH,ENH,LFRAID, 86624,86625,86626,86627,86628);
AddSet(14,ENH,ENH,NORMAL, 85284,85285,85286,85287,85288);
AddSet(14,ENH,ENH,HEROIC, 87134,87135,87136,87137,87138);
AddSet(14,ELE,ELE,LFRAID, 86630,86631,86632,86629,86633);
AddSet(14,ELE,ELE,NORMAL, 85289,85290,85291,85292,85293);
AddSet(14,ELE,ELE,HEROIC, 87139,87140,87141,87142,87143);
-- Warlock
AddSet(14,AFF,DES,LFRAID, 86709,86710,86711,86712,86713);
AddSet(14,AFF,DES,NORMAL, 85369,85370,85371,85372,85373);
AddSet(14,AFF,DES,HEROIC, 87187,87188,87189,87190,87191);
-- Warrior T,M
AddSet(14,PRT,PRT,LFRAID, 86664,86665,86666,86667,86668);
AddSet(14,PRT,PRT,NORMAL, 85324,85325,85326,85327,85328);
AddSet(14,PRT,PRT,HEROIC, 87197,87198,87199,87200,87201);
AddSet(14,ARM,FRY,LFRAID, 86669,86670,86671,86672,86673);
AddSet(14,ARM,FRY,NORMAL, 85329,85330,85331,85332,85333);
AddSet(14,ARM,FRY,HEROIC, 87192,87193,87194,87195,87196);
-- Death Knight T,M
AddSet(14,BLD,BLD,LFRAID, 86654,86655,86656,86657,86658);
AddSet(14,BLD,BLD,NORMAL, 85314,85315,85316,85317,85318);
AddSet(14,BLD,BLD,HEROIC, 86918,86919,86920,86921,86922);
AddSet(14,FRO,UNH,LFRAID, 86674,86675,86676,86677,86678);
AddSet(14,FRO,UNH,NORMAL, 85334,85335,85336,85337,85338);
AddSet(14,FRO,UNH,HEROIC, 86913,86914,86915,86916,86917);

-- "Crackling" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman,monk
-- Conqueror paladin,priest,warlock
RegisterTokens(15,LFRAID,"Dark Animus", 				95822,95823,95824); -- chest
RegisterTokens(15,LFRAID,"Malakk/Mar'li/Kazra'jin/Sul", 95855,95856,95857); -- gauntlets
RegisterTokens(15,LFRAID,"Lu'lin/Suen", 				95879,95880,95881); -- helm
RegisterTokens(15,LFRAID,"Ji-Kun", 						95887,95888,95889); -- leggings
RegisterTokens(15,LFRAID,"Iron Qon", 					95955,95956,95957); -- shoulders
RegisterTokens(15,NORMAL,"Dark Animus", 				95569,95574,95579); -- chest
RegisterTokens(15,NORMAL,"Malakk/Mar'li/Kazra'jin/Sul", 95570,95575,95580); -- gauntlets
RegisterTokens(15,NORMAL,"Lu'lin/Suen", 				95571,95577,95582); -- helm
RegisterTokens(15,NORMAL,"Ji-Kun", 						95572,95576,95581); -- leggings
RegisterTokens(15,NORMAL,"Iron Qon", 					95573,95578,95583); -- shoulders
RegisterTokens(15,HEROIC,"Dark Animus", 				96566,96567,96568); -- chest
RegisterTokens(15,HEROIC,"Malakk/Mar'li/Kazra'jin/Sul", 96599,96600,96601); -- gauntlets
RegisterTokens(15,HEROIC,"Lu'lin/Suen", 				96623,96624,96625); -- helm
RegisterTokens(15,HEROIC,"Ji-Kun", 						96631,96632,96633); -- leggings
RegisterTokens(15,HEROIC,"Iron Qon", 					96699,96700,96701); -- shoulders
-- Druid H,T,M,R
AddSet(15,RST,RST,LFRAID, 95840,95841,95842,95843,95844);
AddSet(15,RST,RST,NORMAL, 95240,95241,95242,95243,95244);
AddSet(15,RST,RST,HEROIC, 96584,96585,96586,96587,96588);
AddSet(15,GRD,GRD,LFRAID, 95850,95851,95852,95853,95854);
AddSet(15,GRD,GRD,NORMAL, 95250,95251,95252,95253,95254);
AddSet(15,GRD,GRD,HEROIC, 96594,96595,96596,96597,96598);
AddSet(15,FRL,FRL,LFRAID, 95835,95836,95837,95838,95839);
AddSet(15,FRL,FRL,NORMAL, 95235,95236,95237,95238,95239);
AddSet(15,FRL,FRL,HEROIC, 96579,96580,96581,96582,96583);
AddSet(15,BAL,BAL,LFRAID, 95845,95846,95847,95848,95849);
AddSet(15,BAL,BAL,NORMAL, 95245,95246,95247,95248,95249);
AddSet(15,BAL,BAL,HEROIC, 96589,96590,96591,96592,96593);
-- Hunter
AddSet(15,BST,SRV,LFRAID, 95882,95883,95884,95885,95886);
AddSet(15,BST,SRV,NORMAL, 95255,95256,95257,95258,95259);
AddSet(15,BST,SRV,HEROIC, 96626,96627,96628,96629,96630);
-- Mage
AddSet(15,ARC,FST,LFRAID, 95890,95891,95892,95893,95894);
AddSet(15,ARC,FST,NORMAL, 95260,95261,95262,95263,95264);
AddSet(15,ARC,FST,HEROIC, 96634,96635,96636,96637,96638);
-- Monk H,T,M
AddSet(15,MST,MST,LFRAID, 95900,95901,95902,95903,95904);
AddSet(15,MST,MST,NORMAL, 95270,95271,95272,95273,95274);
AddSet(15,MST,MST,HEROIC, 96644,96645,96646,96647,96648);
AddSet(15,BRW,BRW,LFRAID, 95905,95906,95907,95908,95909);
AddSet(15,BRW,BRW,NORMAL, 95275,95276,95277,95278,95279);
AddSet(15,BRW,BRW,HEROIC, 96649,96650,96651,96652,96653);
AddSet(15,WND,WND,LFRAID, 95895,95896,95897,95898,95899);
AddSet(15,WND,WND,NORMAL, 95265,95266,95267,95268,95269);
AddSet(15,WND,WND,HEROIC, 96639,96640,96641,96642,96643);
-- Paladin H,T,M
AddSet(15,HOL,HOL,LFRAID, 95915,95916,95917,95918,95919);
AddSet(15,HOL,HOL,NORMAL, 95285,95286,95287,95288,95289);
AddSet(15,HOL,HOL,HEROIC, 96659,96660,96661,96662,96663);
AddSet(15,PRO,PRO,LFRAID, 95920,95921,95922,95923,95924);
AddSet(15,PRO,PRO,NORMAL, 95290,95291,95292,95293,95294);
AddSet(15,PRO,PRO,HEROIC, 96664,96665,96666,96667,96668);
AddSet(15,RET,RET,LFRAID, 95910,95911,95912,95913,95914);
AddSet(15,RET,RET,NORMAL, 95280,95281,95282,95283,95284);
AddSet(15,RET,RET,HEROIC, 96654,96655,96656,96657,96658);
-- Priest H,R
AddSet(15,DSC,HLY,LFRAID, 95925,95926,95927,95928,95929);
AddSet(15,DSC,HLY,NORMAL, 95295,95296,95297,95298,95299);
AddSet(15,DSC,HLY,HEROIC, 96669,96670,96671,96672,96673);
AddSet(15,SHA,SHA,LFRAID, 95930,95931,95932,95933,95934);
AddSet(15,SHA,SHA,NORMAL, 95300,95301,95302,95303,95304);
AddSet(15,SHA,SHA,HEROIC, 96674,96675,96676,96677,96678);
-- Rogue
AddSet(15,ASS,SUB,LFRAID, 95935,95936,95937,95938,95939);
AddSet(15,ASS,SUB,NORMAL, 95305,95306,95307,95308,95309);
AddSet(15,ASS,SUB,HEROIC, 96679,96680,96681,96682,96683);
-- Shaman H,M,R
AddSet(15,RTO,RTO,LFRAID, 95940,95941,95942,95943,95944);
AddSet(15,RTO,RTO,NORMAL, 95310,95311,95312,95313,95314);
AddSet(15,RTO,RTO,HEROIC, 96684,96685,96686,96687,96688);
AddSet(15,ENH,ENH,LFRAID, 95945,95946,95947,95948,95949);
AddSet(15,ENH,ENH,NORMAL, 95315,95316,95317,95318,95319);
AddSet(15,ENH,ENH,HEROIC, 96689,96690,96691,96692,96693);
AddSet(15,ELE,ELE,LFRAID, 95950,95951,95952,95953,95954);
AddSet(15,ELE,ELE,NORMAL, 95320,95321,95322,95323,95324);
AddSet(15,ELE,ELE,HEROIC, 96694,96695,96696,96697,96698);
-- Warlock
AddSet(15,AFF,DES,LFRAID, 95981,95982,95983,95984,95985);
AddSet(15,AFF,DES,NORMAL, 95325,95326,95327,95328,95329);
AddSet(15,AFF,DES,HEROIC, 96725,96726,96727,96728,96729);
-- Warrior T,M
AddSet(15,PRT,PRT,LFRAID, 95991,95992,95993,95994,95995);
AddSet(15,PRT,PRT,NORMAL, 95335,95336,95337,95338,95339);
AddSet(15,PRT,PRT,HEROIC, 96735,96736,96737,96738,96739);
AddSet(15,ARM,FRY,LFRAID, 95986,95987,95988,95989,95990);
AddSet(15,ARM,FRY,NORMAL, 95330,95331,95332,95333,95334);
AddSet(15,ARM,FRY,HEROIC, 96730,96731,96732,96733,96734);
-- Death Knight T,M
AddSet(15,BLD,BLD,LFRAID, 95830,95831,95832,95833,95834);
AddSet(15,BLD,BLD,NORMAL, 95230,95231,95232,95233,95234);
AddSet(15,BLD,BLD,HEROIC, 96574,96575,96576,96577,96578);
AddSet(15,FRO,UNH,LFRAID, 95825,95826,95827,95828,95829);
AddSet(15,FRO,UNH,NORMAL, 95225,95226,95227,95228,95229);
AddSet(15,FRO,UNH,HEROIC, 96569,96570,96571,96572,96573);

-- "Cursed" tokens
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman,monk
-- Conqueror paladin,priest,warlock
RegisterTokens(16,LFRAID,"General Nazgrim", 		99667,99680,99681); -- gauntlets
RegisterTokens(16,LFRAID,"Siegecrafter Blackfuse", 	99668,99669,99670); -- shoulders
RegisterTokens(16,LFRAID,"Thok the Bloodthirsty", 	99671,99672,99673); -- helm
RegisterTokens(16,LFRAID,"Paragons of the Klaxxi", 	99674,99675,99676); -- leggings
RegisterTokens(16,LFRAID,"Sha of Pride", 			99677,99678,99679); -- chest
RegisterTokens(16,LFRAID,"Garrosh Hellscream", 		105860,105861,105862); -- any
RegisterTokens(16,FLEXXI,"Sha of Pride", 			99742,99743,99744); -- chest
RegisterTokens(16,FLEXXI,"General Nazgrim", 		99745,99746,99747); -- gauntlets
RegisterTokens(16,FLEXXI,"Thok the Bloodthirsty", 	99748,99749,99750); -- helm
RegisterTokens(16,FLEXXI,"Paragons of the Klaxxi", 	99751,99752,99753); -- leggings
RegisterTokens(16,FLEXXI,"Siegecrafter Blackfuse", 	99754,99755,99756); -- shoulders
RegisterTokens(16,FLEXXI,"Garrosh Hellscream", 		105863,105864,105865); -- any
RegisterTokens(16,NORMAL,"General Nazgrim", 		99682,99687,99692); -- gauntlets
RegisterTokens(16,NORMAL,"Thok the Bloodthirsty", 	99683,99689,99694); -- helm
RegisterTokens(16,NORMAL,"Paragons of the Klaxxi", 	99684,99688,99693); -- leggings
RegisterTokens(16,NORMAL,"Siegecrafter Blackfuse", 	99685,99690,99695); -- shoulders
RegisterTokens(16,NORMAL,"Sha of Pride", 			99686,99691,99696); -- chest
RegisterTokens(16,NORMAL,"Garrosh Hellscream", 		105857,105858,105859); -- any
RegisterTokens(16,HEROIC,"Paragons of the Klaxxi", 	99712,99713,99726); -- leggings
RegisterTokens(16,HEROIC,"Sha of Pride", 			99714,99715,99716); -- chest
RegisterTokens(16,HEROIC,"Siegecrafter Blackfuse", 	99717,99718,99719); -- shoulders
RegisterTokens(16,HEROIC,"General Nazgrim", 		99720,99721,99722); -- gauntlets
RegisterTokens(16,HEROIC,"Thok the Bloodthirsty", 	99723,99724,99725); -- helm
RegisterTokens(16,HEROIC,"Garrosh Hellscream", 		105866,105867,105868); -- any
-- Druid H,T,M,R
AddSet(16,RST,RST,LFRAID, 99012,99013,99014,99015,99016);
AddSet(16,RST,RST,FLEXXI, 99637,99638,99581,99582,99583);
AddSet(16,RST,RST,NORMAL, 99171,99172,99173,99178,99185);
AddSet(16,RST,RST,HEROIC, 99429,99430,99431,99435,99436);
AddSet(16,GRD,GRD,LFRAID, 98978,98981,98999,99000,99001);
AddSet(16,GRD,GRD,FLEXXI, 99664,99610,99622,99623,99624);
AddSet(16,GRD,GRD,NORMAL, 99163,99164,99165,99166,99170);
AddSet(16,GRD,GRD,HEROIC, 99419,99420,99421,99422,99423);
AddSet(16,FRL,FRL,LFRAID, 99022,99041,99042,99043,99044);
AddSet(16,FRL,FRL,FLEXXI, 99589,99599,99600,99632,99633);
AddSet(16,FRL,FRL,NORMAL, 99180,99181,99182,99183,99184);
AddSet(16,FRL,FRL,HEROIC, 99322,99326,99327,99328,99329);
AddSet(16,BAL,BAL,LFRAID, 98994,98995,98996,98997,98998);
AddSet(16,BAL,BAL,FLEXXI, 99617,99618,99619,99620,99621);
AddSet(16,BAL,BAL,NORMAL, 99169,99174,99175,99176,99177);
AddSet(16,BAL,BAL,HEROIC, 99427,99428,99432,99433,99434);
-- Hunter
AddSet(16,BST,SRV,LFRAID, 99080,99081,99082,99085,99086);
AddSet(16,BST,SRV,FLEXXI, 99660,99573,99574,99577,99578);
AddSet(16,BST,SRV,NORMAL, 99157,99158,99159,99167,99168);
AddSet(16,BST,SRV,HEROIC, 99402,99403,99404,99405,99406);
-- Mage
AddSet(16,ARC,FST,LFRAID, 99077,99078,99079,99083,99084);
AddSet(16,ARC,FST,FLEXXI, 99657,99658,99659,99575,99576);
AddSet(16,ARC,FST,NORMAL, 99152,99153,99160,99161,99162);
AddSet(16,ARC,FST,HEROIC, 99398,99399,99400,99401,99397);
-- Monk H,T,M
AddSet(16,MST,MST,LFRAID, 99061,99062,99068,99069,99070);
AddSet(16,MST,MST,FLEXXI, 99641,99642,99552,99553,99554);
AddSet(16,MST,MST,NORMAL, 99150,99151,99147,99148,99149);
AddSet(16,MST,MST,HEROIC, 99381,99388,99389,99390,99391);
AddSet(16,BRW,BRW,LFRAID, 99050,99051,99063,99064,99065);
AddSet(16,BRW,BRW,FLEXXI, 99565,99606,99607,99643,99644);
AddSet(16,BRW,BRW,NORMAL, 99140,99141,99142,99143,99144);
AddSet(16,BRW,BRW,HEROIC, 99382,99383,99384,99385,99386);
AddSet(16,WND,WND,LFRAID, 99071,99072,99073,99074,99075);
AddSet(16,WND,WND,FLEXXI, 99555,99556,99653,99654,99655);
AddSet(16,WND,WND,NORMAL, 99145,99146,99154,99155,99156);
AddSet(16,WND,WND,HEROIC, 99392,99393,99394,99395,99396);
-- Paladin H,T,M
AddSet(16,HOL,HOL,LFRAID, 99076,98979,98980,98982,99003);
AddSet(16,HOL,HOL,FLEXXI, 99626,99648,99656,99665,99666);
AddSet(16,HOL,HOL,NORMAL, 99124,99125,99133,99134,99135);
AddSet(16,HOL,HOL,HEROIC, 99377,99378,99374,99375,99376);
AddSet(16,PRO,PRO,LFRAID, 99026,99027,99028,99029,99031);
AddSet(16,PRO,PRO,FLEXXI, 99593,99594,99595,99596,99598);
AddSet(16,PRO,PRO,NORMAL, 99126,99127,99128,99129,99130);
AddSet(16,PRO,PRO,HEROIC, 99364,99368,99369,99370,99371);
AddSet(16,RET,RET,LFRAID, 98985,98986,98987,99002,99052);
AddSet(16,RET,RET,FLEXXI, 99625,99651,99661,99662,99566);
AddSet(16,RET,RET,NORMAL, 99132,99136,99137,99138,99139);
AddSet(16,RET,RET,HEROIC, 99372,99373,99379,99380,99387);
-- Priest H,R
AddSet(16,DSC,HLY,LFRAID, 99017,99018,99023,99024,99025);
AddSet(16,DSC,HLY,FLEXXI, 99584,99585,99590,99591,99592);
AddSet(16,DSC,HLY,NORMAL, 99117,99118,99119,99120,99131);
AddSet(16,DSC,HLY,HEROIC, 99357,99358,99365,99366,99367);
AddSet(16,SHA,SHA,LFRAID, 99004,99005,99019,99020,99021);
AddSet(16,SHA,SHA,FLEXXI, 99627,99628,99586,99587,99588);
AddSet(16,SHA,SHA,NORMAL, 99110,99111,99121,99122,99123);
AddSet(16,SHA,SHA,HEROIC, 99359,99360,99361,99362,99363);
-- Rogue
AddSet(16,ASS,SUB,LFRAID, 99006,99007,99008,99009,99010);
AddSet(16,ASS,SUB,FLEXXI, 99629,99630,99631,99634,99635);
AddSet(16,ASS,SUB,NORMAL, 99112,99113,99114,99115,99116);
AddSet(16,ASS,SUB,HEROIC, 99356,99355,99348,99349,99350);
-- Shaman H,M,R
AddSet(16,RTO,RTO,LFRAID, 98988,98989,98990,98991,99011);
AddSet(16,RTO,RTO,FLEXXI, 99611,99612,99613,99614,99636);
AddSet(16,RTO,RTO,NORMAL, 99108,99109,99099,99100,99107);
AddSet(16,RTO,RTO,HEROIC, 99352,99353,99354,99346,99351);
AddSet(16,ENH,ENH,LFRAID, 98977,98983,98984,98992,98993);
AddSet(16,ENH,ENH,FLEXXI, 99615,99616,99649,99650,99663);
AddSet(16,ENH,ENH,NORMAL, 99101,99102,99103,99104,99105);
AddSet(16,ENH,ENH,HEROIC, 99340,99341,99342,99343,99347);
AddSet(16,ELE,ELE,LFRAID, 99087,99088,99089,99090,99091);
AddSet(16,ELE,ELE,FLEXXI, 99579,99580,99645,99646,99647);
AddSet(16,ELE,ELE,NORMAL, 99092,99093,99094,99095,99106);
AddSet(16,ELE,ELE,HEROIC, 99332,99333,99334,99344,99345);
-- Warlock
AddSet(16,AFF,DES,LFRAID, 99045,99053,99054,99055,99056);
AddSet(16,AFF,DES,FLEXXI, 99567,99568,99569,99570,99601);
AddSet(16,AFF,DES,NORMAL, 99096,99097,99098,99204,99205);
AddSet(16,AFF,DES,HEROIC, 99416,99417,99424,99425,99426);
-- Warrior T,M
AddSet(16,PRT,PRT,LFRAID, 99030,99032,99033,99037,99038);
AddSet(16,PRT,PRT,FLEXXI, 99557,99558,99562,99563,99597);
AddSet(16,PRT,PRT,NORMAL, 99195,99196,99201,99202,99203);
AddSet(16,PRT,PRT,HEROIC, 99407,99408,99409,99410,99415);
AddSet(16,ARM,FRY,LFRAID, 99034,99035,99036,99046,99047);
AddSet(16,ARM,FRY,FLEXXI, 99559,99560,99561,99602,99603);
AddSet(16,ARM,FRY,NORMAL, 99197,99198,99199,99200,99206);
AddSet(16,ARM,FRY,HEROIC, 99411,99412,99413,99414,99418);
-- Death Knight T,M
AddSet(16,BLD,BLD,LFRAID, 99039,99040,99048,99049,99060);
AddSet(16,BLD,BLD,FLEXXI, 99564,99604,99605,99640,99652);
AddSet(16,BLD,BLD,NORMAL, 99179,99188,99189,99190,99191);
AddSet(16,BLD,BLD,HEROIC, 99323,99324,99325,99330,99331);
AddSet(16,FRO,UNH,LFRAID, 99057,99058,99059,99066,99067);
AddSet(16,FRO,UNH,FLEXXI, 99571,99572,99608,99609,99639);
AddSet(16,FRO,UNH,NORMAL, 99186,99187,99192,99193,99194);
AddSet(16,FRO,UNH,HEROIC, 99335,99336,99337,99338,99339);

-- "Iron" tokens chest,gloves,legs,helm,shoulders (any horde/alliance)
-- Vanquisher rogue,mage,druid,deathknight
-- Protector warrior,hunter,shaman,monk
-- Conqueror paladin,priest,warlock
--RegisterTokens(17,LFRAID, );
RegisterTokens(17,NORMAL,"Flamebender Ka'graz", 119305,119315,119318); -- chest
RegisterTokens(17,NORMAL,"The Iron Maidens", 	119306,119311,119319); -- gauntlets
RegisterTokens(17,NORMAL,"The Blast Furnace", 	119307,119313,119320); -- leggings
RegisterTokens(17,NORMAL,"Kromog", 				119308,119312,119321); -- helm
RegisterTokens(17,NORMAL,"Operator Thogar", 	119309,119314,119322); -- shoulders
RegisterTokens(17,NORMAL,"Blackhand", 			119310,119316,119323); -- any horde
RegisterTokens(17,NORMAL,"Blackhand", 			120277,120278,120279); -- any alliance
RegisterTokens(17,NORMAL,"Essence Quest", 		120212,120213,120214,120215,120216); -- any conq
RegisterTokens(17,NORMAL,"Essence Quest", 		120217,120218,120219,120220,120221); -- any vanq
RegisterTokens(17,NORMAL,"Essence Quest", 		120222,120223,120224,120225,120226); -- any prot
RegisterTokens(17,HEROIC,"Flamebender Ka'graz", T17(119305,5,570),T17(119315,5,570),T17(119318,5,570)); -- chest
RegisterTokens(17,HEROIC,"The Iron Maidens", 	T17(119306,5,570),T17(119311,5,570),T17(119319,5,570)); -- gauntlets
RegisterTokens(17,HEROIC,"The Blast Furnace", 	T17(119307,5,570),T17(119313,5,570),T17(119320,5,570)); -- leggings
RegisterTokens(17,HEROIC,"Kromog", 				T17(119308,5,570),T17(119312,5,570),T17(119321,5,570)); -- helm
RegisterTokens(17,HEROIC,"Operator Thogar", 	T17(119309,5,570),T17(119314,5,570),T17(119322,5,570)); -- shoulders (problem, protector missing?)
RegisterTokens(17,HEROIC,"Blackhand", 			120206,120207,120208); -- any horde
RegisterTokens(17,HEROIC,"Blackhand", 			120280,120281,120282); -- any alliance
RegisterTokens(17,HEROIC,"Essence Quest", 		120227,120228,120229,120230,120231); -- any vanq
RegisterTokens(17,HEROIC,"Essence Quest", 		120232,120233,120234,120235,120236); -- any prot
RegisterTokens(17,HEROIC,"Essence Quest", 		120237,120238,120239,120240,120241); -- any vanq
RegisterTokens(17,MYTHIC,"Flamebender Ka'graz", T17(119305,6,569),T17(119315,6,569),T17(119318,6,569)); -- chest
RegisterTokens(17,MYTHIC,"The Iron Maidens", 	T17(119306,6,569),T17(119311,6,569),T17(119319,6,569)); -- gauntlets
RegisterTokens(17,MYTHIC,"The Blast Furnace", 	T17(119307,6,569),T17(119313,6,569),T17(119320,6,569)); -- leggings
RegisterTokens(17,MYTHIC,"Kromog", 				T17(119308,6,569),T17(119312,6,569),T17(119321,6,569)); -- helm
RegisterTokens(17,MYTHIC,"Operator Thogar", 	T17(119309,6,569),T17(119314,6,569),T17(119322,6,569)); -- shoulders (problem, protector missing?)
RegisterTokens(17,MYTHIC,"Blackhand", 			120209,120210,120211); -- any horde
RegisterTokens(17,MYTHIC,"Blackhand", 			120283,120284,120285); -- any alliance
RegisterTokens(17,MYTHIC,"Essence Quest", 		120242,120243,120244,120245,120246); -- any prot
RegisterTokens(17,MYTHIC,"Essence Quest", 		120247,120248,120249,120250,120251); -- any vanq
RegisterTokens(17,MYTHIC,"Essence Quest", 		120252,120253,120254,120255,120256); -- any prot
-- Druid H,T,M,R
AddSet(17,BAL,RST,NORMAL, 115540,115541,115542,115543,115544);
AddSet(17,BAL,RST,HEROIC, T17(115540,5,566),T17(115541,5,566),T17(115542,5,566),T17(115543,5,566),T17(115544,5,566));
AddSet(17,BAL,RST,MYTHIC, T17(115540,6,567),T17(115541,6,567),T17(115542,6,567),T17(115543,6,567),T17(115544,6,567));
-- Hunter
AddSet(17,BST,SRV,NORMAL, 115545,115546,115547,115548,115549);
AddSet(17,BST,SRV,HEROIC, T17(115545,5,566),T17(115546,5,566),T17(115547,5,566),T17(115548,5,566),T17(115549,5,566));
AddSet(17,BST,SRV,MYTHIC, T17(115545,6,567),T17(115546,6,567),T17(115547,6,567),T17(115548,6,567),T17(115549,6,567));
-- Mage
AddSet(17,ARC,FST,NORMAL, 115550,115551,115552,115553,115554);
AddSet(17,ARC,FST,HEROIC, T17(115550,5,566),T17(115551,5,566),T17(115552,5,566),T17(115553,5,566),T17(115554,5,566));
AddSet(17,ARC,FST,MYTHIC, T17(115550,6,567),T17(115551,6,567),T17(115552,6,567),T17(115553,6,567),T17(115554,6,567));
-- Monk H,T,M
AddSet(17,BRW,MST,NORMAL, 115555,115556,115557,115558,115559);
AddSet(17,BRW,MST,HEROIC, T17(115555,5,566),T17(115556,5,566),T17(115557,5,566),T17(115558,5,566),T17(115559,5,566));
AddSet(17,BRW,MST,MYTHIC, T17(115555,6,567),T17(115556,6,567),T17(115557,6,567),T17(115558,6,567),T17(115559,6,567));
-- Paladin H,T,M
AddSet(17,HOL,PRO,NORMAL, 115565,115566,115567,115568,115569);
AddSet(17,HOL,PRO,HEROIC, T17(115565,5,566),T17(115566,5,566),T17(115567,5,566),T17(115568,5,566),T17(115569,5,566));
AddSet(17,HOL,PRO,MYTHIC, T17(115565,6,567),T17(115566,6,567),T17(115567,6,567),T17(115568,6,567),T17(115569,6,567));
AddSet(17,RET,RET,NORMAL, 115565,115566,115567,115568,115569);
AddSet(17,RET,RET,HEROIC, T17(115565,5,566),T17(115566,5,566),T17(115567,5,566),T17(115568,5,566),T17(115569,5,566));
AddSet(17,RET,RET,MYTHIC, T17(115565,6,567),T17(115566,6,567),T17(115567,6,567),T17(115568,6,567),T17(115569,6,567));
-- Priest H,R
AddSet(17,DSC,SHA,NORMAL, 115560,115561,115562,115563,115564);
AddSet(17,DSC,SHA,HEROIC, T17(115560,5,566),T17(115561,5,566),T17(115562,5,566),T17(115563,5,566),T17(115564,5,566));
AddSet(17,DSC,SHA,MYTHIC, T17(115560,6,567),T17(115561,6,567),T17(115562,6,567),T17(115563,6,567),T17(115564,6,567));
-- Rogue
AddSet(17,ASS,SUB,NORMAL, 115570,115571,115572,115573,115574);
AddSet(17,ASS,SUB,HEROIC, T17(115570,5,566),T17(115571,5,566),T17(115572,5,566),T17(115573,5,566),T17(115574,5,566));
AddSet(17,ASS,SUB,MYTHIC, T17(115570,6,567),T17(115571,6,567),T17(115572,6,567),T17(115573,6,567),T17(115574,6,567));
-- Shaman H,M,R
AddSet(17,ELE,RTO,NORMAL, 115575,115576,115577,115578,115579);
AddSet(17,ELE,RTO,HEROIC, T17(115575,5,566),T17(115576,5,566),T17(115577,5,566),T17(115578,5,566),T17(115579,5,566));
AddSet(17,ELE,RTO,MYTHIC, T17(115575,6,567),T17(115576,6,567),T17(115577,6,567),T17(115578,6,567),T17(115579,6,567));
-- Warlock
AddSet(17,AFF,DES,NORMAL, 115585,115586,115587,115588,115589);
AddSet(17,AFF,DES,HEROIC, T17(115585,5,566),T17(115586,5,566),T17(115587,5,566),T17(115588,5,566),T17(115589,5,566));
AddSet(17,AFF,DES,MYTHIC, T17(115585,6,567),T17(115586,6,567),T17(115587,6,567),T17(115588,6,567),T17(115589,6,567));
-- Warrior T,M
AddSet(17,ARM,PRT,NORMAL, 115580,115581,115582,115583,115584);
AddSet(17,ARM,PRT,HEROIC, T17(115580,5,566),T17(115581,5,566),T17(115582,5,566),T17(115583,5,566),T17(115584,5,566));
AddSet(17,ARM,PRT,MYTHIC, T17(115580,6,567),T17(115581,6,567),T17(115582,6,567),T17(115583,6,567),T17(115584,6,567));
-- Death Knight T,M
AddSet(17,BLD,UNH,NORMAL, 115535,115536,115537,115538,115539);
AddSet(17,BLD,UNH,HEROIC, T17(115535,5,566),T17(115536,5,566),T17(115537,5,566),T17(115538,5,566),T17(115539,5,566));
AddSet(17,BLD,UNH,MYTHIC, T17(115535,6,567),T17(115536,6,567),T17(115537,6,567),T17(115538,6,567),T17(115539,6,567));

------------------------------------------------------------------------------------------------------------------------------------]]
local _,Class = UnitClass("player");

TTTDebug = false;
local function dbg(...)
	if (TTTDebug) then
		print(...);
	end
end

-- item:itemID:enchant:gemID1:gemID2:gemID3:gemID4:suffixID:uniqueID:level:upgradeID:instanceDifficultyID:numBonusIDs:bonusID1:bonusID2:...
local function GetIDFromLink(link)
	if link then
		if (link:match("item:(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+):(%d+)")) then -- T17 item
			local strid = link:match("(item:.*)|h%["); -- damn invisible |h ****! 
			dbg("id from link",strid);
			return strid;
		else
			local id = link:match("item:(%d+)");
			dbg("id from link",id);
			return tonumber(id);
		end
	end
	return 0;
end

local function GetInvSlotFromLink(link)
	local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(link);
	local loclist = {"INVTYPE_HEAD","INVTYPE_SHOULDER","INVTYPE_CHEST","INVTYPE_HAND","INVTYPE_LEGS"};
	
	if (itemEquipLoc) then
		for _,inv in ipairs(loclist) do
			if (itemEquipLoc == inv) then
				dbg("valid equiploc",inv);
				return itemEquipLoc,itemLink;
			end
		end
		if (itemEquipLoc == "INVTYPE_ROBE") then -- apparently robes have a different inventory type to chest :/
			return "INVTYPE_CHEST",itemLink;
		end
	end
	if (itemTexture) then
		local slot = itemTexture:match(".*INV_(%a-)_");
		dbg("getinvslot",itemName,itemLink,itemType,itemSubType,itemEquipLoc,itemTexture);
-- thanks Blizz for being consistent with your texture naming ... NOT!
		if (itemType == "Miscellaneous" and slot and slot:lower() == "misc") then
			local scanlist = {Pants="INVTYPE_LEGS"};
			dbg("dodgy item check",itemTexture);
			for str,inv in pairs(scanlist) do
				if (itemTexture:match(str)) then
					dbg("replaced misc with",str,inv);
					return inv,itemLink;
				end
			end
		end
		if (slot) then
			local lslot = slot:lower();
			local translate = {
								helmet="INVTYPE_HEAD",
								shoulder="INVTYPE_SHOULDER",
								chest="INVTYPE_CHEST",
								gauntlets="INVTYPE_HAND",
								pants="INVTYPE_LEGS",
							  };
			for str,inv in pairs(translate) do
				if (lslot == str) then
					dbg("translated slot",lslot,inv);
					return inv,itemLink;
				end
			end
			dbg("untranslated slot",lslot);
			return lslot,itemLink; -- texture name can be in all uppercase or normal case
		end
	end
	dbg("no location info!",link);
	return nil,nil;
end

-- tooltip stuff (Blizz likes to call this repeatedly when highlighting the same item)
local TTTipEJFix = CreateFrame("GameTooltip","TTTipEJFix",UIParent,"GameTooltipTemplate");
local function ttthookset(self)
	local name,link = self:GetItem();
	local id = GetIDFromLink(link);
-- check if a different item is being inspected
	if (self.TTTlasttoken ~= id) then
		local tier,diff,source,canuse,slot;
		if (Tokens[id]) then
			tier,diff,source = Tokens[id].tier,Tokens[id].diff,Tokens[id].source;
			slot = GetInvSlotFromLink(link);
-- player can use this token type?
			local toktype = name:match("%a-$");
			canuse = ClassMap[toktype] and Tokens[id].tier >= (ClassMap[toktype][Class] or 99);
			dbg("usable",canuse);
		end
		self.TTTrewardid = nil;
-- is it a tier token with a valid inv slot?
		if (tier and slot) then
			self.TTTline1 = "TTT: "..Tiers[tier];
			self.TTTline2 = "Dropped By: "..source;
			self.TTTline3 = "ID: "..id.." Slot: "..(_G[slot] or slot);
-- is there a converted item for the players spec?
			if (canuse and Sets[tier] and Sets[tier][diff]) then
				local spec = GetSpecializationInfo(GetSpecialization());
				if (Sets[tier][diff][spec]) then
					dbg("finding set match",tier,diff,spec);
					for _,id in ipairs(Sets[tier][diff][spec]) do
						local setslot,setlink = GetInvSlotFromLink(id);
						if (setslot == slot) then
							self.TTTrewardid = id;
							print("TTT:",link,"creates",setlink);
							break;
						end
						if (slot == "misc") then -- show all items
							print("TTT:",link,"creates",setlink);
						end
					end
					dbg("rewardid",self.TTTrewardid);
				end
			end
		else
			self.TTTline1,self.TTTline2,self.TTTline3 = nil,nil,nil;
		end
		self.TTTlasttoken = id;
	end
-- output cached info
	if (self.TTTrewardid) then
		local TTTip = unpack(self.shoppingTooltips);
		local valid,hlink = GetItemInfo(self.TTTrewardid);
		if (valid) then -- wait for data to be sent by the server
			-- EncounterJournal_Loot_OnUpdate ruins the tooltip
			local o = self:GetOwner();
			if (o and o:GetName():match("EncounterJournal")) then
				dbg("encounter journal alternate method");
				TTTip = TTTipEJFix;
			end
			TTTip:SetOwner(self,"ANCHOR_NONE");
			TTTip:ClearAllPoints();
			local rightDist = GetScreenWidth() - (self:GetRight() or 0);
			if (rightDist < (self:GetLeft() or 0)) then
				TTTip:SetPoint("TOPRIGHT",self,"TOPLEFT",0,0);
			else
				TTTip:SetPoint("TOPLEFT",self,"TOPRIGHT",0,0);
			end
			TTTip:SetHyperlink(hlink);
			TTTip:Show();
			dbg("showing created item tip",TTTip:GetName(),TTTip:IsShown());
		end
	end
	if (self.TTTline1 and self.TTTline2 and self.TTTline3) then
		self:AddLine(self.TTTline1);
		self:AddLine(self.TTTline2);
		self:AddLine(self.TTTline3);
	end
end

local function ttthookclear()
	TTTipEJFix:Hide();
end

GameTooltip:HookScript("OnTooltipSetItem",ttthookset);
ItemRefTooltip:HookScript("OnTooltipSetItem",ttthookset);
GameTooltip:HookScript("OnTooltipCleared",ttthookclear);

local function printlink(id)
	local name,link = GetItemInfo(id);
	if (name) then
		print("TTT: item",id,"is",link);
	else -- not cached locally yet
		print("item id",id,"waiting for server (try again in a moment)");
	end
end

-- command line handler
local function handler(msg)
	if (strlen(msg) > 0) then
		local t = tonumber(msg);
		if (t and t >= 4 and t <= 17) then
			print("TTT: Tier",t,"token list...");
			for id,token in pairs(Tokens) do
				if (token.tier == t) then
					printlink(id);
				end
			end
		else
			printlink(msg);
			dbg("token array entry",Tokens[msg]);
		end
	end
end

SLASH_TTTSLASH1 = '/tttip';
SlashCmdList["TTTSLASH"] = handler;
